// Tcollection for C++
// (c) 1997

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include "collection.h"

tCollection::tCollection():tObject("tCollection")
{
	count=0;
	items = NULL;
	limit = 2;
	expand = 2;

	//items = (tArray*)malloc(limit*PTRSIZE);
	items = (pArray)new (void*)[limit];
}

tCollection::tCollection(int l, int e):tObject("tCollection")
{
	count=0;
	items = NULL;
	limit = l;
	expand = e;
	//items = (tArray*)malloc(limit*PTRSIZE);
	items = (pArray)new (void*)[limit];
}

tCollection::~tCollection()
{
	//printf("delete %d items...\n", count-1);
	for(int i=0; i<count; i++)
	{
		//delete (*items)[i];
		delete (tCollection*)Get(i);
	}
	//printf("free my item pointers...\n");
	//free(items);
	delete items;
}

int tCollection::Count()
{
	return count;
}

void tCollection::Add(tObject *a)
{
	checkexpand();
	(*items)[count] = a;
	count++;
}

void tCollection::DeleteAt(int i)
{
	*items[i]=NULL;
	memcpy(&items[i], &items[i+1], PTRSIZE * (count-i));
}

void tCollection::Delete(tObject *d)
{
}

tObject *tCollection::Get(int i)
{
	return (*items)[i];
}

void tCollection::checkexpand()
{
	void	*tmp;

	if(count==limit)
	{
		// erweitern der Collection

		//tmp = malloc((limit+expand)*PTRSIZE);
		tmp = new (void*)[(limit+expand)];

		if (tmp==NULL)
		{
			printf("ERROR in Mem-Handling\n");
			exit(1);
		}

		tmp = memcpy(tmp, items, (limit*PTRSIZE));

		//items = realloc(items, (limit+expand)*PTRSIZE);

		limit+=expand;

		//free(items);
		delete items;

		items = (tArray*)tmp;     // ;-))

		return;
	}
	if(count>limit)
	{
		printf("tCollection: Expand-ERROR!!!!\n");
		exit(1);
	}
}
