// Tcollection
// collections for C++ ;-))

#ifndef __COLLECTION_H

#define __COLLECTION_H

#include "object.h"

#define PTRSIZE sizeof(void*)
#define MAXSIZE	262144

typedef	tObject*        tArray[MAXSIZE];
typedef	tArray		*pArray;

class tCollection: public tObject {
	public:
		tCollection();
		tCollection(int l, int e);
		virtual ~tCollection();

		void	Add(tObject *a);
		void	DeleteAt(int i);
		void	Delete(tObject *d);
		int		Count();
		tObject	*Get(int i);

	protected:
		tArray	*items;
		int		count;

		int		limit;
		int		expand;

		void	checkexpand();
};

typedef	tCollection	*pCollection;

#endif
