// Utils like log-function, etc...

#include <stdio.h>
#include <fstream.h>
#include <errno.h>

#include "util.h"

// Logfile

// LOGLEVELS
// 0 - alles
// 1 - Infos
// 2 - nur Fehler

int LOGLEVEL = 0;

char *logname;

void openlog(char *filename)
{
	logname = new char[strlen(filename)+1];
	strcpy(logname, filename);
}

void closelog()
{
	delete logname;
}

void logmsg(char *msg, int level = 0)
{
	FILE *logfile;

	logfile = fopen(logname, "a");
	if(logfile!=NULL) {}
	else
	{
		printf("logfehler (%d)....\n", errno);
		exit(-1);
	}

	if(level >= LOGLEVEL)
	{
		fprintf(logfile, "[kumu/%d]: %s\n", level, msg);
	}
	fclose(logfile);
}
